CodeForces 670D1 暴力或二分

 

今天,开博客,,,激动,第一次啊
嗯,,先来发水题纪念一下

 

D1. Magic Powder - 1

 

This problem is given in two versions that differ only by constraints. If you can solve this problem in large constraints, then you can just write a single solution to the both versions. If you find the problem too difficult in large constraints, you can write solution to the simplified version only.

Waking up in the morning, Apollinaria decided to bake cookies. To bake one cookie, she needs n ingredients, and for each ingredient she knows the value ai — how many grams of this ingredient one needs to bake a cookie. To prepare one cookie Apollinaria needs to use alln ingredients.

Apollinaria has bi gram of the i-th ingredient. Also she has k grams of a magic powder. Each gram of magic powder can be turned to exactly 1 gram of any of the n ingredients and can be used for baking cookies.

Your task is to determine the maximum number of cookies, which Apollinaria is able to bake using the ingredients that she has and the magic powder.

Input

The first line of the input contains two positive integers n and k (1 ≤ n, k ≤ 1000) — the number of ingredients and the number of grams of the magic powder.

The second line contains the sequence a1, a2, ..., an (1 ≤ ai ≤ 1000), where the i-th number is equal to the number of grams of the i-th ingredient, needed to bake one cookie.

The third line contains the sequence b1, b2, ..., bn (1 ≤ bi ≤ 1000), where the i-th number is equal to the number of grams of the i-th ingredient, which Apollinaria has.

Output

Print the maximum number of cookies, which Apollinaria will be able to bake using the ingredients that she has and the magic powder.

Examples

input

3 12 1 4
11 3 16

output

4

input

4 3
4 3 5 6
11 12 14 20

output

3

Note

In the first sample it is profitably for Apollinaria to make the existing 1 gram of her magic powder to ingredient with the index 2, then Apollinaria will be able to bake 4 cookies.

In the second sample Apollinaria should turn 1 gram of magic powder to ingredient with the index 1 and 1 gram of magic powder to ingredient with the index 3. Then Apollinaria will be able to bake 3 cookies. The remaining 1 gram of the magic powder can be left, because it can't be used to increase the answer.

 

1、CodeForces 670D1

2、链接:http://codeforces.com/problemset/problem/670/D1

3、总结:

题意,给出n种做一个饼干所要的材料数,n种现有材料数,k个可变化材料,求可做多少饼干。

可暴力,也可直接二分。

 

 

小数据直接暴力

#include<iostream>
#include<cstring>
#include<cmath>
#include<queue>
#include<algorithm>
#include<cstdio>
#define max(a,b) (a>b?a:b)
#define abs(a) ((a)>0?(a):-(a))
using namespace std;
#define LL long long
#define INF 0x3f3f3f3f
int main()
{
    int n,k;
    int a[1500],b[1500];
    while(scanf("%d%d",&n,&k)!=EOF)
    {
        for(int i=0;i<n;i++)scanf("%d",&a[i]);
        for(int i=0;i<n;i++)scanf("%d",&b[i]);
        int aa,flag=0;
        int num=0;
        while(k>=0)         //k>=0,不要k>0
        {
            for(int i=0;i<n;i++){       //找到个数最小点,标记  
                if(aa>b[i]/a[i]){
                    flag=i;
                    aa=b[i]/a[i];
                }
            }
            //下面更新记录
            int bb=a[flag]-b[flag]%a[flag];
            if(k<bb)break;
            else {
                k-=bb;
                b[flag]+=bb;
                aa=b[flag]/a[flag];
            }

        }
        cout<<aa<<endl;
    }
    return 0;
}

 

 

大数据二分
参考了http://blog.csdn.net/qiuxueming_csdn/article/details/51471935

#include<iostream>
#include<cstring>
#include<cmath>
#include<queue>
#include<algorithm>
#include<cstdio>
#define max(a,b) (a>b?a:b)
#define abs(a) ((a)>0?(a):-(a))
using namespace std;
#define LL long long
#define INF 0x3f3f3f3f
int n,k;
int a[1000000],b[1000000];
bool ok(LL mid)
{
    LL kk=k;
    for(int i=0;i<n;i++){
        if(a[i]*mid>b[i]){
            kk-=(a[i]*mid-b[i]);

        }
        if(kk<0)return false;   //mid太大,跳出; 不能放到上面if里
    }
    return true;        //mid太小,使k有剩余
}
int main()
{
    while(~scanf("%d%d",&n,&k))
    {
        for(int i=0;i<n;i++)
            scanf("%d",&a[i]);
        for(int i=0;i<n;i++)
            scanf("%d",&b[i]);
        LL l=0,r=INF;
        LL num,mid;
        while(l<=r)
        {
            mid=(l+r)>>1;
            if(ok(mid)){
                l=mid+1;
                num=mid;        //num要在这里赋值
            }else {
                r=mid-1;
            }
        }
        cout<<num<<endl;
    }
    return 0;
}
原文地址:https://www.cnblogs.com/sbfhy/p/5700545.html